Package org.apache.commons.codec.binary

# Class Base32OutputStream

java.lang.Object
java.io.OutputStream
java.io.FilterOutputStream
org.apache.commons.codec.binary.BaseNCodecOutputStream
org.apache.commons.codec.binary.Base32OutputStream

All Implemented Interfaces:
  `Closeable`, `Flushable`, `AutoCloseable`

public class Base32OutputStream extends BaseNCodecOutputStream
Provides Base32 encoding and decoding in a streaming fashion (unlimited size). When encoding the default lineLength is 76 characters and the default lineEnding is CRLF, but these can be overridden by using the appropriate constructor.

The default behavior of the Base32OutputStream is to ENCODE, whereas the default behavior of the Base32InputStream is to DECODE. But this behavior can be overridden by using a different constructor.

Since this class operates directly on byte streams, and not character streams, it is hard-coded to only encode/decode character encodings which are compatible with the lower 127 ASCII chart (ISO-8859-1, Windows-1252, UTF-8, etc).

Note: It is mandatory to close the stream after the last byte has been written to it, otherwise the final padding will be omitted and the resulting data will be incomplete/inconsistent.

You can set the decoding behavior when the input bytes contain leftover trailing bits that cannot be created by a valid encoding. These can be bits that are unused from the final character or entire characters. The default mode is lenient decoding.

- Lenient: Any trailing bits are composed into 8-bit bytes where possible. The remainder are discarded.
- Strict: The decoding will raise an `IllegalArgumentException` if trailing bits are not part of a valid encoding. Any unused bits from the final character must be zero. Impossible counts of entire final characters are not allowed.

When strict decoding is enabled it is expected that the decoded bytes will be re-encoded to a byte array that matches the original, i.e. no changes occur on the final character. This requires that the input bytes use the same padding and alphabet as the encoder.

Since:
  1.5
See Also:
  - RFC 4648

- ## Field Summary

  ### Fields inherited from class java.io.FilterOutputStream

  `out`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Base32OutputStream(OutputStream outputStream)`
  Constructs a Base32OutputStream such that all data written is Base32-encoded to the original provided OutputStream.
  `Base32OutputStream(OutputStream outputStream, boolean doEncode)`
  Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.
  `Base32OutputStream(OutputStream outputStream, boolean doEncode, int lineLength, byte[] lineSeparator)`
  Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.
  `Base32OutputStream(OutputStream outputStream, boolean doEncode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)`
  Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.

- ## Method Summary

  ### Methods inherited from class org.apache.commons.codec.binary.BaseNCodecOutputStream

  `close, eof, flush, isStrictDecoding, write, write`

  ### Methods inherited from class java.io.FilterOutputStream

  `write`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### Base32OutputStream

    public Base32OutputStream(OutputStream outputStream)
    Constructs a Base32OutputStream such that all data written is Base32-encoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.

  - ### Base32OutputStream

    public Base32OutputStream(OutputStream outputStream, boolean doEncode)
    Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `doEncode` - true if we should encode all data written to us, false if we should decode.

  - ### Base32OutputStream

    public Base32OutputStream(OutputStream outputStream, boolean doEncode, int lineLength, byte[] lineSeparator)
    Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `doEncode` - true if we should encode all data written to us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.

  - ### Base32OutputStream

    public Base32OutputStream(OutputStream outputStream, boolean doEncode, int lineLength, byte[] lineSeparator, CodecPolicy decodingPolicy)
    Constructs a Base32OutputStream such that all data written is either Base32-encoded or Base32-decoded to the original provided OutputStream.
    Parameters:
      `outputStream` - OutputStream to wrap.
      `doEncode` - true if we should encode all data written to us, false if we should decode.
      `lineLength` - If doEncode is true, each line of encoded data will contain lineLength characters (rounded down to the nearest multiple of 4). If lineLength <= 0, the encoded data is not divided into lines. If doEncode is false, lineLength is ignored.
      `lineSeparator` - If doEncode is true, each line of encoded data will be terminated with this byte sequence (e.g. \r\n). If lineLength <= 0, the lineSeparator is not used. If doEncode is false lineSeparator is ignored.
      `decodingPolicy` - The decoding policy.
    Since:
      1.15